/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
// サンプルログ集計ロジック・クラス
// 
//
//	変更履歴
//	2004/01/08 新規作成	T.Nishiki
//
package jp.co.ntt.lms.xms.framework.sample;

import java.sql.ResultSet;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

import org.apache.commons.lang.StringEscapeUtils;

import jp.co.ntt.lms.xmo.DataAccess;
import jp.co.ntt.lms.xms.framework.XmsException;
import jp.co.ntt.lms.xms.framework.XmsSystemException;
import jp.co.ntt.lms.xms.framework.base.Logic;
import jp.co.ntt.lms.xms.framework.base.LogicResult;

/**
 * サンプルログ集計ロジック・クラス。<br>
 * 
 * @author nishiki
 */
public class SampleLogSumUp implements Logic {

	private List userIdList;
	private List loIdList;

	public SampleLogSumUp(List userIdList, List loIdList ) {
		this.userIdList = userIdList;
		this.loIdList   = loIdList;
	}

	/**
	 * 集計ロジック・メソッド。<br>
	 * LoLogSessionテーブルにアクセスし、
	 * userID、LOID、SessionID、study_start_date、study_end_dateの
	 * 各列を取得し、SampleLogResultクラスのオブジェクトにデータを格納する。
	 * 
	 * @param dataAccess データアクセス・クラス
	 * @return 集計結果（SampleLogResult）
	 * @throws XmsException データアクセスなどで問題が発生した場合。
	 * @see SampleLogResult
	 */
	public LogicResult doLogic(DataAccess dataAccess) throws XmsException {
		SampleLogResult result = null;
		ResultSet rs = null;
		boolean exceptionFlag = false;
		try {
			result = new SampleLogResult();
			// クエリ生成
			StringBuffer sbSQL = new StringBuffer();
			sbSQL.append("SELECT userID" );
			sbSQL.append(", LOID ");
			sbSQL.append(", SessionID");
			sbSQL.append(", study_start_date");
			sbSQL.append(", study_end_date ");
			sbSQL.append(" FROM LOLogSession");
			//==================================================================
			// WHERE句の生成
			StringBuffer sbWhere = new StringBuffer();
			// ユーザIDの条件
			StringBuffer sbWhereUserId = new StringBuffer();
			if ( userIdList != null ) {
				for ( Iterator iterator = userIdList.iterator(); iterator.hasNext(); ) {
					String userId = null;
					userId = (String)iterator.next();
					sbWhereUserId.append( " OR userID='" + StringEscapeUtils.escapeSql(userId) + "'" );
				}
				if ( sbWhereUserId.length() > 0 ) {
					sbWhere.append( " AND (" + sbWhereUserId.substring(4) + ")" );
				}
			}
			// LOIDの条件
			StringBuffer sbWhereLoId = new StringBuffer();
			if ( loIdList != null ) {
				for ( Iterator iterator = loIdList.iterator(); iterator.hasNext(); ) {
					String loId = null;
					loId = (String)iterator.next();
					sbWhereLoId.append( " OR LOID='" + StringEscapeUtils.escapeSql(loId) + "'" );
				}
				if ( sbWhereLoId.length() > 0 ) {
					sbWhere.append( " AND (" + sbWhereLoId.substring(4) + ")" );
				}
			}
			// where句の連結
			if ( sbWhere.length() > 0 ) {
				sbSQL.append( " WHERE " + sbWhere.substring(5) );
			}
			
			sbSQL.append(" ORDER BY userID,LOID");

			// クエリ発行
			rs = dataAccess.executeQuery(sbSQL.toString());

			// 発行結果を結果クラスに格納
			String userId    = null;
			String loId      = null;
			String sessionId = null;
			Date   startDate = null;
			Date   endDate   = null;
			while (rs.next()) {
				userId    = rs.getString("userID");
				loId      = rs.getString("LOID");
				sessionId = rs.getString("SessionID");
				startDate = rs.getDate("study_start_date");
				endDate   = rs.getDate("study_end_date");

				result.addLog(userId, loId, sessionId, startDate, endDate);
			}
			exceptionFlag = true;
		} catch (Exception e) {
			throw new XmsSystemException(e);
		} finally {
			if (rs != null) {
				try {
					rs.close();
				} catch (Exception e) {
					if ( exceptionFlag == true ) {
						throw new XmsSystemException( e );
					}
				}
				rs = null;
			}
		}
		return result;
	}

}
